Index: roard/driver.c
===================================================================
--- roard/driver.c	(revision 6052)
+++ roard/driver.c	(revision 0)
@@ -1,270 +1,49 @@
-//driver.c:
 
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #include "roard.h"
 
 struct roar_driver g_driver[] = {
- { "null", "null audio driver", NULL, STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-   NULL, NULL, NULL},
+ { "null", "null audio driver", "/dev/null", NULL, NULL, NULL, NULL, NULL, NULL},
 #ifdef ROAR_HAVE_ESD
- { "esd", "EsounD audio driver", "localhost, remote.host.dom", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-   NULL, NULL, driver_esd_open_vio},
+ { "esd", "EsounD audio driver", "localhost, remote.host.dom", driver_esd_open, driver_esd_close, driver_esd_pause, driver_esd_write, driver_esd_read, driver_esd_flush},
 #endif
- { "roar", "RoarAudio driver", "localhost, remote.host.dom", STREAM_DIR_OUT, DRV_FLAG_NONE,
-   ROAR_SUBSYS_WAVEFORM|ROAR_SUBSYS_MIDI|ROAR_SUBSYS_LIGHT|ROAR_SUBSYS_COMPLEX,
-   NULL, NULL, driver_roar_open_vio},
-#ifndef ROAR_WITHOUT_VIO_DSTR
- { "dstr", "VIO DSTR driver", "/some/file", STREAM_DIR_OUT, DRV_FLAG_FHSEC,
-   ROAR_SUBSYS_WAVEFORM|ROAR_SUBSYS_MIDI|ROAR_SUBSYS_LIGHT|ROAR_SUBSYS_RAW|ROAR_SUBSYS_COMPLEX,
-   NULL, NULL, driver_dstr_open_vio},
+ { "roar", "RoarAudio driver", "localhost, remote.host.dom", driver_roar_open, driver_roar_close, driver_roar_pause, driver_roar_write, driver_roar_read, driver_roar_flush},
+#ifdef ROAR_HAVE_LIBAO
+ { "ao", "libao audio driver", "DRIVER", driver_ao_open, driver_ao_close, driver_ao_pause, driver_ao_write, driver_ao_read, driver_ao_flush},
 #endif
-#if defined(ROAR_HAVE_OSS_BSD) || defined(ROAR_HAVE_OSS)
-#ifndef ROAR_DEFAULT_OSS_DEV
-#define ROAR_DEFAULT_OSS_DEV "no default device"
-#endif
- { "oss", "Open Sound System", ROAR_DEFAULT_OSS_DEV, STREAM_DIR_BIDIR, DRV_FLAG_FHSEC, ROAR_SUBSYS_WAVEFORM,
-   NULL, NULL, driver_oss_open},
-#endif
-#ifdef ROAR_HAVE_LIBAO
- { "ao", "libao audio driver", "DRIVER", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-   NULL, NULL, driver_ao_open_vio},
-#endif
-#ifdef ROAR_HAVE_LIBSHOUT
- {"shout", "libshout streaming", "http://user:pw@host:port/mount.ogg", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_shout_open_vio},
-#endif
-#ifdef ROAR_HAVE_LIBSNDIO
- {"sndio", "OpenBSD sndio", "/dev/audio, /tmp/aucat-<uid>/default", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM|ROAR_SUBSYS_MIDI,
-  NULL, NULL, driver_sndio_open},
-#endif
-#ifdef ROAR_HAVE_LIBRSOUND
- {"rsound", "RSound", "servername", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_rsound_open},
-#endif
-#ifdef _DRIVER_PORTAUDIO_CAN_OPERATE
- {"portaudio", "PortAudio", NULL, STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_portaudio_open},
-#endif
-#ifdef ROAR_HAVE_LIBASOUND
- {"alsa", "ALSA", "???", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM, NULL, NULL, driver_alsa_open_vio},
-#endif
-#ifdef ROAR_HAVE_LIBWINMM
- {"wmm", "Win32 MM", "???", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM, NULL, NULL, driver_wmm_open_vio},
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_DMX
- {"dmx", "DMX512 driver", "/dev/dmx", STREAM_DIR_OUT, DRV_FLAG_FHSEC, ROAR_SUBSYS_LIGHT,
-  NULL, NULL, driver_dmx_open_vio},
-#endif
-#if !defined(ROAR_WITHOUT_DCOMP_PWMLED) && !defined(ROAR_WITHOUT_VIO_DSTR)
- {"pwmled", "PWM LED driver", "/dev/ttyS0", STREAM_DIR_OUT, DRV_FLAG_FHSEC, ROAR_SUBSYS_LIGHT,
-  NULL, NULL, driver_pwmled_open_vio},
-#endif
-#ifdef ROAR_HAVE_DRIVER_I2CDMX
- {"i2cdmx", "I^2C DMX Interface driver", "/dev/i2c-1", STREAM_DIR_BIDIR, DRV_FLAG_NONE, ROAR_SUBSYS_LIGHT,
-  NULL, NULL, driver_i2cdmx_open_vio},
-#endif
-#ifdef ROAR_HAVE_DRIVER_SYSCLOCK
- {"sysclock", "System Clock Clock Source", NULL, STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_sysclock_open_vio},
-#endif
-#ifndef ROAR_WITHOUT_DCOMP_CDRIVER
- {"cdriver", "RoarAudio Client driver", "driver#device", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_cdriver_open},
-#endif
-#ifdef ROAR_HAVE_LIBPULSE
- {"pulsesimple", "PulseAudio Simple", "server", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_pulsesimple_open},
-#endif
-#ifdef ROAR_HAVE_LIBJACK
-#if 0
- // this is currently just a driver stub.
- {"jack", "JACK", "???", STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_jack_open_vio},
-#endif
-#endif
-#ifdef ROAR_HAVE_LIBARTSC
- {"artsc", "aRts plain C API", NULL, STREAM_DIR_OUT, DRV_FLAG_NONE, ROAR_SUBSYS_WAVEFORM,
-  NULL, NULL, driver_artsc_open_vio},
-#endif
- {NULL, NULL, NULL, STREAM_DIR_NONE, DRV_FLAG_NONE, 0, NULL, NULL, NULL} // end of list
+ {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL} // end of list
                                 };
 
-void print_driverlist (enum output_format format) {
+void print_driverlist (void) {
  int i;
- char subsys[7] = "      ";
- char mode[5]   = "    ";
-
- switch (format) {
-  case FORMAT_NATIVE:
-    printf("  Driver       Mode Flag Subsys - Description (devices)\n");
-    printf("---------------------------------------------------------------\n");
-   break;
-  case FORMAT_WIKI:
-    printf("||=Driver =||=Mode =||=Flag =||=Subsys =||=Description =||=Devices =||\n");
-   break;
-  case FORMAT_CSV:
-    printf("Driver,Mode,Flag,Subsys,Description,Devices\n");
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_NOTSUP);
-    return;
- }
 
  for (i = 0; g_driver[i].name != NULL; i++) {
-  strncpy(subsys, "      ", 6);
-  strncpy(mode,   "    ",   4);
-
-  if ( g_driver[i].mode & STREAM_DIR_IN )
-   mode[0] = 'r';
-  if ( g_driver[i].mode & STREAM_DIR_OUT )
-   mode[1] = 'w';
-
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_WAVEFORM )
-   subsys[0] = 'W';
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_MIDI )
-   subsys[1] = 'M';
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_CB )
-   subsys[2] = 'C';
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_LIGHT )
-   subsys[3] = 'L';
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_RAW )
-   subsys[4] = 'R';
-  if ( g_driver[i].subsystems & ROAR_SUBSYS_COMPLEX )
-   subsys[5] = 'X';
-
-  switch (format) {
-   case FORMAT_NATIVE:
-     if ( g_driver[i].devices != NULL ) {
-      printf("  %-12s %4s %c%c%c%c %6s - %s (devices: %s)\n", g_driver[i].name,
-                    mode,
-                    ' ', /* unused Flag */
-                    g_driver[i].flags & DRV_FLAG_FHSEC                                                         ? 's' : ' ',
-                    g_driver[i].open     != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? 'S' : ' ',
-                    g_driver[i].vio_init != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? 'V' : ' ',
-                    subsys,
-                    g_driver[i].desc, g_driver[i].devices);
-     } else {
-      printf("  %-12s %4s %c%c%c%c %6s - %s\n", g_driver[i].name,
-                    mode,
-                    ' ', /* unused Flag */
-                    g_driver[i].flags & DRV_FLAG_FHSEC                                                         ? 's' : ' ',
-                    g_driver[i].open     != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? 'S' : ' ',
-                    g_driver[i].vio_init != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? 'V' : ' ',
-                    subsys,
-                    g_driver[i].desc);
-     }
-    break;
-   case FORMAT_WIKI:
-     printf("||=%-12s =|| %s || %s%s%s ||%s ||%s ||%s ||\n", g_driver[i].name, mode[0] == ' ' ? mode+1 : mode,
-                    g_driver[i].flags & DRV_FLAG_FHSEC                                                         ? "s" : " ",
-                    g_driver[i].open     != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? "S" : " ",
-                    g_driver[i].vio_init != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? "V" : " ",
-                    subsys,
-                    g_driver[i].desc, g_driver[i].devices == NULL ? "" : g_driver[i].devices);
-    break;
-   case FORMAT_CSV:
-     printf("%s,%s,%s%s%s,%s,%s,%s\n", g_driver[i].name, mode,
-                    g_driver[i].flags & DRV_FLAG_FHSEC                                                         ? "s" : " ",
-                    g_driver[i].open     != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? "S" : " ",
-                    g_driver[i].vio_init != NULL || (g_driver[i].open == NULL && g_driver[i].vio_init == NULL) ? "V" : " ",
-                    subsys,
-                    g_driver[i].desc, g_driver[i].devices == NULL ? "" : g_driver[i].devices);
-    break;
-  }
+  printf("  %-8s - %s (devices: %s)\n", g_driver[i].name, g_driver[i].desc, g_driver[i].devices);
  }
 }
 
-int driver_openvio(struct roar_vio_calls * calls,
-                 int * driver_id, char * driver /* NOTE: this is not part of struct roar_driver's def! */,
-                 char * device, struct roar_audio_info * info, int fh,
-                 struct roar_stream_server * sstream) {
+int driver_open (DRIVER_USERDATA_T * inst, int * driver_id, char * driver, char * device, struct roar_audio_info * info) {
  int i;
 
-#ifdef ROAR_DRIVER_DEFAULT
  if ( driver == NULL )
   driver = ROAR_DRIVER_DEFAULT;
-#else
- if ( driver == NULL )
-  return -1;
-#endif
-
-#ifdef ROAR_DRIVER_DEVICE
- if ( device == NULL )
-  device = ROAR_DRIVER_DEVICE;
-#endif
-
- ROAR_DBG("driver_openvio(*): searching for driver '%s'...", driver);
 
  for (i = 0; g_driver[i].name != NULL; i++) {
   if ( strcmp(g_driver[i].name, driver) == 0 ) {
-   ROAR_DBG("driver_openvio(*): found driver: id = %i", i);
+   ROAR_DBG("driver_open(*): found driver: id = %i", i);
 
    *driver_id = i;
 
-   ROAR_DBG("driver_openvio(*): driver found: %s -> %i", driver, i);
-
-   if ( g_driver[i].vio_init == NULL ) {
-    if ( g_driver[i].open == NULL ) { // this is the null driver
-     memset(calls, 0, sizeof(struct roar_vio_calls));
-     calls->flags = ROAR_VIO_FLAGS_NONE;
-     calls->refc  = 1;
-     calls->read  = roar_vio_null_rw;
-     calls->write = roar_vio_null_rw;
-     return 0;
-    }
-
-    ROAR_WARN("driver_openvio(*): driver(%s) uses old non-vio interface!", driver);
-    ROAR_ERR("driver_openvio(calls=%p, driver_id={%i}, driver='%s', device='%s', info=%p, fh=%i): not a VIO driver!",
-        calls, i, driver, device, info, fh);
-    return -1;
-   }
-
-   // if this driver does not support input we need to check if it is used in input mode.
-   if ( !(g_driver[i].mode & STREAM_DIR_IN) ) {
-    if ( sstream == NULL )
-     return -1;
-
-    if ( streams_get_flag(ROAR_STREAM(sstream)->id, ROAR_FLAG_RECSOURCE) ) {
-     if ( streams_get_flag(ROAR_STREAM(sstream)->id, ROAR_FLAG_AUTOCONF) == 1 ) {
-      if ( streams_reset_flag(ROAR_STREAM(sstream)->id, ROAR_FLAG_RECSOURCE) == -1 )
-       return -1;
-     } else {
-      ROAR_WARN("driver_openvio(*): driver(%s) is not abled to record data and autoconf flag is not set.", driver);
-      return -1;
-     }
-    }
-   }
-
-   ROAR_DBG("driver_openvio(*): Opening VIO driver %s(%i)...", driver, i);
-   return g_driver[i].vio_init(calls, device, info, fh, sstream);
+   if ( g_driver[i].open )
+    return g_driver[i].open(inst, device, info);
+   return 0;
   }
  }
+
  return -1;
 }
 
-int driver_closevio(struct roar_vio_calls * calls, int driver) {
- ROAR_DBG("driver_closevio(calls=%p, driver=%i) = ?", calls, driver);
+int driver_close(DRIVER_USERDATA_T   inst, int driver) {
+ ROAR_DBG("driver_close(inst=%p, driver=%i) = ?", inst, driver);
 
  if ( driver == -1 )
@@ -272,83 +51,47 @@
 
  if ( g_driver[driver].close )
-  return g_driver[driver].close((DRIVER_USERDATA_T)calls);
-
- if ( calls->close != NULL )
-  roar_vio_close(calls);
+  return g_driver[driver].close(inst);
 
  return 0;
 }
 
-int driver_set_volume(int stream, struct roar_mixer_settings * mixer) {
- struct roar_stream_server * ss;
-
- if ( (ss = g_streams[stream]) == NULL )
+int driver_pause(DRIVER_USERDATA_T   inst, int driver, int newstate) {
+ if ( driver == -1 )
   return -1;
 
- if ( !streams_get_flag(stream, ROAR_FLAG_HWMIXER) )
-  return 0;
+ if ( g_driver[driver].pause )
+  return g_driver[driver].pause(inst, newstate);
 
- if ( ss->driver_id == -1 )
+ return 0;
+}
+
+int driver_write(DRIVER_USERDATA_T   inst, int driver, char * buf, int len) {
+ if ( driver == -1 )
   return -1;
 
- return roar_vio_ctl(&(ss->vio), ROAR_VIO_CTL_SET_VOLUME, (void*)mixer);
+ if ( g_driver[driver].write )
+  return g_driver[driver].write(inst, buf, len);
+
+ return 0;
 }
 
+int driver_read (DRIVER_USERDATA_T   inst, int driver, char * buf, int len) {
+ if ( driver == -1 )
+  return -1;
 
-#ifndef ROAR_WITHOUT_DCOMP_CDRIVER
-int driver_cdriver_open(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh, struct roar_stream_server * sstream) {
- char * driver;
- char * delm;
- int ret;
+ if ( g_driver[driver].read )
+  return g_driver[driver].read(inst, buf, len);
 
- (void)sstream;
+ return 0;
+}
 
- ROAR_DBG("driver_cdriver_open(inst=%p, device='%s', info=%p, fh=%i, sstream=%p) = ?", inst, device, info, fh, sstream);
+int driver_flush(DRIVER_USERDATA_T   inst, int driver) {
+ if ( driver == -1 )
+  return -1;
 
- if ( fh != -1 ) {
-  roar_err_set(ROAR_ERROR_NOTSUP);
-  return -1;
- }
+ if ( g_driver[driver].flush )
+  return g_driver[driver].flush(inst);
 
- if (device == NULL) {
-  driver = NULL;
- } else {
-  driver = roar_mm_strdup(device);
-
-  if ( (delm = strstr(driver, "#")) == NULL ) {
-   device = NULL;
-  } else {
-   *delm  = 0;
-   device = strstr(device, "#") + 1;
-  }
- }
-
- ROAR_DBG("driver_cdriver_open(*): CALL roar_cdriver_open(inst=%p, driver='%s', device='%s', info=%p, dir=ROAR_DIR_PLAY)", inst, driver, device, info);
- ret = roar_cdriver_open(inst, driver, device, info, ROAR_DIR_PLAY);
- ROAR_DBG("driver_cdriver_open(*): RET %i", ret);
-
- if ( driver != NULL )
-  roar_mm_free(driver);
-
- return ret;
-}
-#endif
-
-int  driver_dummy_ctl(struct roar_vio_calls * vio, roar_vio_ctl_t cmd, void * data) {
- (void)vio;
-
- switch (cmd) {
-  case ROAR_VIO_CTL_NONBLOCK:
-    if ( *(const int*)data == ROAR_SOCKET_BLOCK )
-     return 0;
-
-    roar_err_set(ROAR_ERROR_NOTSUP);
-    return -1;
-   break;
-  default:
-    roar_err_set(ROAR_ERROR_BADRQC);
-    return -1;
-   break;
- }
+ return 0;
 }
 
Index: roard/driver_ao.c
===================================================================
--- roard/driver_ao.c	(revision 6052)
+++ roard/driver_ao.c	(revision 0)
@@ -1,63 +1,12 @@
-//driver_ao.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
+//driver_esd.c:
 
 #include "roard.h"
-#ifdef ROAR_HAVE_LIBAO
 
-static int _driver_ao_usage_counter = 0;
-
-void driver_ao_init (void) {
- if ( _driver_ao_usage_counter++ == 0 )
-  ao_initialize();
-
-#ifdef ROAR_HAVE_AO_APPEND_GLOBAL_OPTION
- ao_append_global_option("client_name", "roard");
-#endif
-}
-
-void driver_ao_uninit (void) {
- if ( _driver_ao_usage_counter-- == 1 )
-  ao_shutdown();
-}
-
-int driver_ao_open_vio(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh, struct roar_stream_server * sstream) {
-//int driver_ao_open(DRIVER_USERDATA_T * inst, char * device, struct roar_audio_info * info) {
+int driver_ao_open(DRIVER_USERDATA_T * inst, char * device, struct roar_audio_info * info) {
  ao_device        * aodevice;
  ao_sample_format     format;
  int driver;
- int autoconfig = 0;
 
- ROAR_WARN("The libao driver is obsolete, use another!");
-
- if ( fh != -1 )
-  return -1;
-
- if ( sstream != NULL ) {
-  autoconfig = streams_get_flag(ROAR_STREAM(sstream)->id, ROAR_FLAG_AUTOCONF);
- }
-
- driver_ao_init();
+ ao_initialize();
 
  if ( device == NULL ) {
@@ -66,94 +15,49 @@
   if ( (driver = ao_driver_id(device)) == -1 ) {
    ROAR_ERR("Can not open audio device via libao's driver '%s'", device);
-   driver_ao_uninit();
    return -1;
   }
  }
 
- memset(&format, 0, sizeof(format));
-
  format.bits        = info->bits;
  format.channels    = info->channels;
  format.rate        = info->rate;
-
- if ( info->bits == 8 ) {
-  ROAR_WARN("This is the libao driver in 8 bit mode, It's not known to me if I need to provide data in signed or in unsigned mode. If your musik sounds strange try -oO codec=pcm_s_le or -oO codec=pcm_u_be");
-/* NOTE: the following is only true for EsounD driver, not for OSS driver, don't know for the others
-  switch (info->codec) {
-   case ROAR_CODEC_PCM_U_LE:
-   case ROAR_CODEC_PCM_U_BE:
-   case ROAR_CODEC_PCM_U_PDP:
-     format.byte_format = AO_FMT_NATIVE;
-    break;
-   default:
-     ROAR_ERR("Can not open audio device via libao: codec not supported. You may want to try -oO codec=pcm_u_le or -oO codec=pcm,bits=16");
-     driver_ao_uninit();
-     return -1;
-    break;
-  }
-*/
- }
-
- switch (info->codec) {
-  case ROAR_CODEC_PCM_S_LE:
-    format.byte_format = AO_FMT_LITTLE;
-   break;
-  case ROAR_CODEC_PCM_S_BE:
-    format.byte_format = AO_FMT_BIG;
-   break;
-  default:
-    if ( autoconfig ) {
-     format.byte_format = AO_FMT_NATIVE;
-     info->codec = ROAR_CODEC_DEFAULT;
-    } else {
-     ROAR_ERR("Can not open audio device via libao: codec not supported. You may want to try -oO codec=pcm");
-     driver_ao_uninit();
-     return -1;
-    }
-   break;
- }
+ format.byte_format = AO_FMT_NATIVE;
 
  aodevice = ao_open_live(driver, &format, NULL /* no options */);
 
- if ( aodevice == NULL && autoconfig ) {
-  format.byte_format = AO_FMT_NATIVE;
-  format.bits        = 16;
-  info->codec        = ROAR_CODEC_DEFAULT;
-  info->bits         = 16;
-  aodevice = ao_open_live(driver, &format, NULL /* no options */);
- }
-
  if ( aodevice == NULL ) {
   ROAR_ERR("Can not open audio device via libao.");
-  driver_ao_uninit();
   return -1;
  }
 
- memset(inst, 0, sizeof(struct roar_vio_calls));
- inst->flags    = ROAR_VIO_FLAGS_NONE;
- inst->refc     = 1;
- inst->inst     = (void*) aodevice;
- inst->write    = driver_ao_write;
- inst->close    = driver_ao_close;
- inst->ctl      = driver_dummy_ctl;
+ *((ao_device**)inst) = aodevice;
 
  return 0;
 }
 
-int driver_ao_close(struct roar_vio_calls * vio) {
+int driver_ao_close(DRIVER_USERDATA_T   inst) {
 
- ao_close((ao_device*)vio->inst);
+ ao_close((ao_device*)inst);
 
- driver_ao_uninit();
+ ao_shutdown();
 
+ return -1;
+}
+
+int driver_ao_pause(DRIVER_USERDATA_T   inst, int newstate) {
+ return -1;
+}
+
+int driver_ao_write(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ return ao_play((ao_device*)inst, buf, len);
+}
+
+int driver_ao_read(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ return -1;
+}
+
+int driver_ao_flush(DRIVER_USERDATA_T   inst) {
  return 0;
 }
 
-ssize_t driver_ao_write(struct roar_vio_calls * vio, void *buf, size_t count) {
- if ( ao_play((ao_device*)(vio->inst), buf, count) == 0 )
-  return -1;
- return count;
-}
-
-#endif
 //ll
Index: roard/driver_esd.c
===================================================================
--- roard/driver_esd.c	(revision 6052)
+++ roard/driver_esd.c	(revision 0)
@@ -1,72 +1,66 @@
 //driver_esd.c:
 
+#include "roard.h"
+
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
+ We could use inst as our fh directly. But esd works with unsigned at 8 bits and
+ signed at 16 bits per sample. (why???) so we need to convert because we get signed at both,
+ 8 and 16 bits per sample. so we use inst as an array of two ints: 0: fh, 1: are we in 8 bit mode?
+*/
 
-#include "roard.h"
-#ifdef ROAR_HAVE_ESD
+int driver_esd_open(DRIVER_USERDATA_T * inst, char * device, struct roar_audio_info * info) {
+ esd_format_t format = ESD_STREAM | ESD_PLAY;
+ char name[80] = "roard";
+ int * di = malloc(sizeof(int)*2);
 
-int driver_esd_open_vio(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh, struct roar_stream_server * sstream) {
- esd_format_t format = ESD_STREAM | ESD_PLAY;
- const char * name = "roard";
-
- (void)sstream;
-
- if ( fh != -1 )
+ if ( di == NULL )
   return -1;
 
- if ( info->bits >= 16 ) {
-  info->bits  = 16;
-  format     |= ESD_BITS16;
-  info->codec = ROAR_CODEC_PCM_S;
- } else if ( info->bits < 16 ) {
-  info->bits  =  8;
-  format     |= ESD_BITS8;
-  info->codec = ROAR_CODEC_PCM_U;
+ *inst = (DRIVER_USERDATA_T)di;
+
+ format |= info->bits     == 16 ? ESD_BITS16 : ESD_BITS8;
+ format |= info->channels ==  2 ? ESD_STEREO : ESD_MONO;
+
+ di[1] = info->bits == 8;
+
+ di[0] = esd_play_stream_fallback(format, info->rate, device, name);
+
+ if ( di[0] == -1 ) {
+  free(di);
+  *inst = NULL;
+  return -1;
  }
-
- if ( info->channels >= 2 ) {
-  info->channels  = 2;
-  format         |= ESD_STEREO;
- } else {
-  info->channels  = 1;
-  format         |= ESD_MONO;
- }
-
- fh = esd_play_stream_fallback(format, info->rate, device, name);
-
-
- // test for error.
- if ( fh == -1 )
-  return -1;
-
- roar_vio_open_fh_socket(inst, fh);
-
- roar_vio_shutdown(inst, ROAR_VIO_SHUTDOWN_READ);
 
  return 0;
 }
 
+int driver_esd_close(DRIVER_USERDATA_T   inst) {
+ int fh = *(int*)inst;
 
-#endif
+ free((void*)inst);
+
+ return esd_close(fh);
+}
+
+int driver_esd_pause(DRIVER_USERDATA_T   inst, int newstate) {
+ return -1;
+}
+
+int driver_esd_write(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ int * di = (int*)inst;
+
+ if ( di[1] )
+  roar_conv_codec_s2u8(buf, buf, len);
+
+ return write(di[0], buf, len);
+}
+
+int driver_esd_read(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ return read(*(int*)inst, buf, len);
+}
+
+int driver_esd_flush(DRIVER_USERDATA_T   inst) {
+ return 0;
+}
+
 //ll
Index: roard/driver_roar.c
===================================================================
--- roard/driver_roar.c	(revision 6052)
+++ roard/driver_roar.c	(revision 0)
@@ -1,65 +1,49 @@
-//driver_roar.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
+//driver_esd.c:
 
 #include "roard.h"
 
-#define MIXER_ID -1
+int driver_roar_open(DRIVER_USERDATA_T * inst, char * device, struct roar_audio_info * info) {
+/*
+ esd_format_t format = ESD_STREAM | ESD_PLAY;
+ char name[80] = "roard";
 
-int driver_roar_open_vio(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh, struct roar_stream_server * sstream) {
- int dir = ROAR_DIR_PLAY;
+ format |= info->bits     == 16 ? ESD_BITS16 : ESD_BITS8;
+ format |= info->channels ==  2 ? ESD_STEREO : ESD_MONO;
 
- if ( fh != -1 ) { // this is a connection to a roard, no roar_simple_*() interface avalible for this case
+ *(int*)inst = esd_play_stream_fallback(format, info->rate, device, name);
+
+ if ( *(int*)inst == -1 )
   return -1;
- }
 
- if ( sstream != NULL ) {
-  switch (ROAR_STREAM(sstream)->dir) {
-   case ROAR_DIR_OUTPUT:      dir = ROAR_DIR_PLAY;       break;
-   case ROAR_DIR_MIDI_OUT:    dir = ROAR_DIR_MIDI_IN;    break;
-   case ROAR_DIR_LIGHT_OUT:   dir = ROAR_DIR_LIGHT_IN;   break;
-// TODO: we need to know a real pos id for raw streams...
-//   case ROAR_DIR_RAW_OUT:   dir = ROAR_DIR_RAW_IN;   break;
-   case ROAR_DIR_COMPLEX_OUT: dir = ROAR_DIR_COMPLEX_IN; break;
-   default:
-     return -1;
-  }
- }
+ return 0;
+*/
 
- if ( roar_vio_simple_stream(inst, info->rate, info->channels, info->bits, info->codec, device, dir, "roard", MIXER_ID) == -1 ) {
-  if ( streams_get_flag(ROAR_STREAM(sstream)->id, ROAR_FLAG_AUTOCONF) ) {
-   if ( roar_profile2info(info, "default") == -1 )
-    return -1;
+ *(int*)inst =  roar_simple_play(info->rate, info->channels, info->bits, info->codec, device, "roard");
 
-   if ( roar_vio_simple_stream(inst, info->rate, info->channels, info->bits, info->codec, device, dir, "roard", MIXER_ID) == -1 ) {
-    return -1;
-   }
-  }
+ if ( *(int*)inst == -1 )
   return -1;
- }
 
  return 0;
 }
 
+int driver_roar_close(DRIVER_USERDATA_T   inst) {
+ return roar_simple_close((int)inst);
+}
+
+int driver_roar_pause(DRIVER_USERDATA_T   inst, int newstate) {
+ return -1;
+}
+
+int driver_roar_write(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ return write((int)inst, buf, len);
+}
+
+int driver_roar_read(DRIVER_USERDATA_T   inst, char * buf, int len) {
+ return read((int)inst, buf, len);
+}
+
+int driver_roar_flush(DRIVER_USERDATA_T   inst) {
+ return 0;
+}
+
 //ll
Index: roard/empty.c
===================================================================
--- roard/empty.c	(revision 6052)
+++ roard/empty.c	(revision 0)
@@ -1,26 +1,3 @@
 //*.c:
-
-/*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2013-2015
- *
- *  This file is part of roard a part of RoarAudio,
- *  a cross-platform sound system for both, home and professional use.
- *  See README for details.
- *
- *  This file is free software; you can redistribute it and/or modify
- *  it under the terms of the GNU General Public License version 3
- *  as published by the Free Software Foundation.
- *
- *  RoarAudio is distributed in the hope that it will be useful,
- *  but WITHOUT ANY WARRANTY; without even the implied warranty of
- *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *  GNU General Public License for more details.
- *
- *  You should have received a copy of the GNU General Public License
- *  along with this software; see the file COPYING.  If not, write to
- *  the Free Software Foundation, 51 Franklin Street, Fifth Floor,
- *  Boston, MA 02110-1301, USA.
- *
- */
 
 #include "roard.h"
